<template>
  <div class="documents q-pa-md q-gutter-md">
    <q-uploader
        url="https://crm1-api.technik-crm.ru/upload-file"
        :headers="[
            {name: 'Authorization', value: `Bearer ${token}`}
        ]"
        @finish="finish"
        label="Загрузка файлов"
        field-name="file"
        batch
        color="grey-9"
    />
    <q-separator/>
    <div class="text-h5">Каталог файлов</div>
    <div class="my-card">
      <q-card v-for="doc in documents" flat bordered class="" :class="$q.dark.isActive ? 'bg-grey-9' : 'bg-grey-2'">
        <q-card-section>
          <div class="row items-center no-wrap">
            <div class="col">
              <div class="text-h6 ellipsis-2-lines">{{doc.name}}</div>
              <div class="text-subtitle2">Формат: {{doc.extension}}</div>
              <div class="text-subtitle2">Загружено: {{formattedDate(doc.createdAt, true)}}</div>
            </div>
            <div class="col-auto">
              <q-avatar v-if="isImageExtension.includes(doc.extension)" rounded size="50px" class="q-mt-md">
                <img :src="`https://crm1-api.technik-crm.ru${doc.destination}`" alt="">
              </q-avatar>
            </div>
          </div>
        </q-card-section>
        <q-card-actions align="right">
          <q-btn v-if="roleMiddleware(['ADMIN'])" @click="deleteFile(doc._id)" color="grey-7" round flat icon="delete" />
          <q-btn color="grey-7" round flat icon="download" :href="`https://technik-crm.ru${doc.destination}`" target="_blank" />
        </q-card-actions>
      </q-card>
    </div>
  </div>
</template>

<script>
import {computed, onMounted, ref} from "vue";
import api from "../API/api";
import formattedDate from "../components/utils/formatDate";
import {roleMiddleware} from '../components/roleMiddleware';
import {useStore} from "vuex";

export default {
  name: "Documents",
  setup () {
    const store = useStore()
    const token = store.state.token
    const documents = ref([])

    onMounted(async () => {
      await api.getDocuments().then(res => {documents.value = res.data.documents})
    })

    async function finish () {
      location.reload()
    }

    async function deleteFile (_id) {
      await api.deleteDocument({_id}).then(() => {
        documents.value = documents.value.filter(el => el._id !== _id)
      })
    }

    return {
      formattedDate,
      roleMiddleware,
      documents,
      finish,
      deleteFile,
      token,

      isImageExtension: computed(() => {
        return ['jpg', 'JPG', 'jpeg', 'png'];
      })
    }
  }
}
</script>

<style scoped lang="scss">
.documents {
  display: grid;
  grid-template-columns: 1fr;
  max-height: calc(100vh - 40px);
  overflow: hidden;
  .my-card {
    overflow: auto;
    display: grid;
    grid-template-columns: repeat(auto-fill, minmax(280px, 1fr)); /* Замените 200px на желаемую ширину колонки */
    gap: 20px; /* Установите нужный промежуток между колонками */
    max-height: calc(100vh - 280px);
  }
}
</style>
